## nfs-ganesha 4.3

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
# NFS Ganesha  Cmake

# Current version as of Fedora 16.  Not tested with earlier.

cmake_minimum_required(VERSION 2.6.3)

message( STATUS "cmake version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" )

if( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )
  if(COMMAND cmake_policy)
      cmake_policy(SET CMP0017 NEW)
  endif(COMMAND cmake_policy)
endif( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )

# Set GANESHA_TOP_CMAKE_DIR to this CMakeLists.txt path
set(GANESHA_TOP_CMAKE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${GANESHA_TOP_CMAKE_DIR}/cmake/modules/")

project(nfs-ganesha C CXX)
# Project versioning
set(GANESHA_MAJOR_VERSION 4)
# Minor version is blank for development.  On release, it becomes ".0".  On a
# stable maintenance branch, this becomes ".N" where N is monotonically
# increasing starting at 1. Remember to include the "." !!
set(GANESHA_MINOR_VERSION .3)

IF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
set(GANESHA_BUILD_RELEASE 1)
ELSE()
set(GANESHA_BUILD_RELEASE 0)
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")

# needs to come after project()
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
	SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Install prefix for common files" FORCE)
	message(STATUS "override default CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "/etc" CACHE PATH "Install prefix for common files")
	SET(SYSSTATEDIR "/var" CACHE PATH "Install prefix for common files")
ELSE()
	message(STATUS "was set CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "Install prefix for common files")
	SET(SYSSTATEDIR "${CMAKE_INSTALL_PREFIX}/var" CACHE PATH "Install prefix for common files")
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")

SET(RUNTIMEDIR "${SYSSTATEDIR}/run/ganesha" CACHE PATH "Runtime directory (for things like pid file, not touched by install)")

# Extra version is for naming development/RC.  It is blank in stable branches
# so it can be available to end-users to name local variants/versions
# If used, it is always of the form "-whateveryouwant"
set(GANESHA_EXTRA_VERSION )

set(GANESHA_VERSION ${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}${GANESHA_EXTRA_VERSION})
set(GANESHA_BASE_VERSION ${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION})

set(VERSION_COMMENT
  "GANESHA file server is 64 bits compliant and supports NFS v3,4.0,4.1 (pNFS) and 9P"
)

# find out which platform we are building on
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(LINUX ON)
  set(UNIX ON)
  # Now detects the Linux's distro
  set(DISTRO "UNKNOWN")
  set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/libexec")

  EXECUTE_PROCESS(
      COMMAND awk -F=  "/^NAME=/ { print $2 }" /etc/os-release
      OUTPUT_VARIABLE SYS_RELEASE
      ERROR_QUIET
   )
  EXECUTE_PROCESS(
      COMMAND awk -F=  "/^ID_LIKE=/ { print $2 }" /etc/os-release
      OUTPUT_VARIABLE ID_LIKE
   )
# Red Hat Enterprise Linux versions before 7.0 will be detected as UNKNOWN

  if( ${SYS_RELEASE} MATCHES "Red Hat" )
     message( STATUS "Detected a Linux Red Hat machine" )
     set(DISTRO "RED_HAT")
  elseif( ${SYS_RELEASE} MATCHES "Fedora" )
     message( STATUS "Detected a Linux Fedora machine" )
     set(DISTRO "FEDORA")
  elseif( ${SYS_RELEASE} MATCHES "SLES" )
     message( STATUS "Detected a Linux SLES machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  elseif( ${SYS_RELEASE} MATCHES "openSUSE Leap" )
     message( STATUS "Detected a Linux openSUSE Leap machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  elseif( ${SYS_RELEASE} MATCHES "openSUSE Tumbleweed" )
     message( STATUS "Detected a Linux openSUSE Tumbleweed machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  elseif( (${SYS_RELEASE} MATCHES "Debian GNU/Linux") OR (${SYS_RELEASE} MATCHES "Ubuntu") )
     message( STATUS "Detected a Linux Debian base machine" )
     set(DISTRO "DEBIAN")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  else( ${SYS_RELEASE} MATCHES "Red Hat" )
     if( ${ID_LIKE} MATCHES "suse" )
         message( STATUS "Detected a SUSE Build server machine" )
         set(DISTRO "SLES")
         set(LIBEXECDIR "/usr/lib")
     else( ${ID_LIKE} MATCHES "suse" )
         message( STATUS "Detected an UNKNOWN Linux machine" )
         set(DISTRO "UNKNOWN")
     endif( ${ID_LIKE} MATCHES "suse" )
  endif( ${SYS_RELEASE} MATCHES "Red Hat" )
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(BSDBASED ON)
  set(FREEBSD ON)
  set(UNIX ON)
# On FreeBSD libc doesn't directly provide libexecinfo, so we have to find it
  set(USE_EXECINFO ON)
  set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/libexec")
endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(BSDBASED ON)
  set(DARWIN ON)
  set(UNIX ON)
  set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/libexec")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(WINDOWS ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

if(DARWIN)
  # Apple's /usr/bin/ld doesn't use the same flags for specifying treatment of
  # undefined symbols, and its defaults are opposite of GNU's and LLVM's ld.
  set(LDFLAG_ALLOW_UNDEF "-Wl,-undefined,suppress")
  set(LDFLAG_DISALLOW_UNDEF "-Wl,-undefined,error")
elseif(FREEBSD OR LINUX)
  # llvm-ld seems to be missing a flag to explicitly allow undefined, but this
  # is the default anyway for both llvm-ld and GNU ld.
  set(LDFLAG_ALLOW_UNDEF "")
  set(LDFLAG_DISALLOW_UNDEF "-Wl,--no-undefined")
endif(DARWIN)

# Identify the host we are building on
EXECUTE_PROCESS( COMMAND hostname
  OUTPUT_VARIABLE BUILD_HOST_NAME
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )

find_package(Toolchain REQUIRED)
find_package(Sanitizers)

# Add maintainer mode for (mainly) strict builds
include(${GANESHA_TOP_CMAKE_DIR}/cmake/maintainer_mode.cmake)

# For libraries that provide pkg-config files
include(FindPkgConfig)

# For our option system
include(${GANESHA_TOP_CMAKE_DIR}/cmake/goption.cmake)

# If we are in a git tree, then this CMakeLists.txt is in "src/" and go .git is in "src/.."
IF( EXISTS ${GANESHA_TOP_CMAKE_DIR}/../.git/HEAD  )
  message( STATUS "Compilation from within a git repository. Using git rev-parse HEAD")
  EXECUTE_PROCESS( COMMAND git rev-parse HEAD
		   WORKING_DIRECTORY ${GANESHA_TOP_CMAKE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_HEAD_COMMIT)
  EXECUTE_PROCESS( COMMAND git describe --long
                   WORKING_DIRECTORY  ${GANESHA_TOP_CMAKE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_DESCRIBE)

ELSE( EXISTS ${GANESHA_TOP_CMAKE_DIR}/../.git/HEAD  )
  message( STATUS "Outside a git repository, use saved data" )
  EXEC_PROGRAM(${GANESHA_TOP_CMAKE_DIR}/cmake/githead_from_path.sh ARGS ${GANESHA_TOP_CMAKE_DIR}
                OUTPUT_VARIABLE  _GIT_HEAD_COMMIT)

  EXEC_PROGRAM(${GANESHA_TOP_CMAKE_DIR}/cmake/gitdesc_from_path.sh ARGS ${GANESHA_TOP_CMAKE_DIR}
                OUTPUT_VARIABLE  _GIT_DESCRIBE)

ENDIF( EXISTS ${GANESHA_TOP_CMAKE_DIR}/../.git/HEAD  )

STRING(SUBSTRING ${_GIT_HEAD_COMMIT} 0  7 _GIT_HEAD_COMMIT_ABBREV )

if (BSDBASED)
#default gcc doesn't like using -Wuninitialized without -O on FreeBSD
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -ggdb")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-optimize-sibling-calls")
endif(BSDBASED)

if (FREEBSD)
    set(PLATFORM "FREEBSD")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/freebsd")
endif(FREEBSD)

if (DARWIN)
    set(PLATFORM "DARWIN")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-export_dynamic")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/darwin")
endif(DARWIN)

if (LINUX)
    set(PLATFORM "LINUX")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/linux")
endif(LINUX)

if (MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# Library path name
get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib64 CACHE PATH
		"Specify name of libdir inside install path")
else (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH
		"Specify name of libdir inside install path")
endif (USE_LIB64)

IF(FSAL_DESTINATION)
    set( FSAL_DESTINATION ${FSAL_DESTINATION} )
ELSE()
    set( FSAL_DESTINATION "${LIB_INSTALL_DIR}/ganesha")
ENDIF()

if (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")
  # uname -p is broken on this system.  Try uname -m
  EXECUTE_PROCESS( COMMAND uname -m
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
		   OUTPUT_VARIABLE ARCH)
else (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")
  set(ARCH ${CMAKE_SYSTEM_PROCESSOR})
endif (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")

if (ARCH MATCHES "x86_64")
  # Nothing special to do for x86_64
elseif (ARCH MATCHES "i386")
  # Nothing special to do for i386
elseif (ARCH MATCHES "mips")
  set(SYSTEM_LIBRARIES "-latomic" ${SYSTEM_LIBRARIES})
else()
  message(WARNING "Unhandled architecture ${ARCH}")
endif ()

# FSAL selection
# FSALs which are enabled by default but could be disabled
# during the build
goption(USE_FSAL_PROXY_V4 "build PROXY_V4 FSAL shared library" ON)
goption(USE_FSAL_PROXY_V3 "build PROXY_V3 FSAL shared library" ON)
goption(USE_FSAL_VFS "build VFS FSAL shared library" ON)
goption(USE_FSAL_LUSTRE "build LUSTRE FSAL shared library" ON)
goption(USE_FSAL_LIZARDFS "build LIZARDFS FSAL shared library" ON)
goption(USE_FSAL_KVSFS "build KVSFS FSAL shared library" ON)
goption(USE_FSAL_CEPH "build CEPH FSAL shared library" ON)
goption(USE_FSAL_GPFS "build GPFS FSAL" ON)
goption(USE_FSAL_XFS "build XFS support in VFS FSAL" ON)
goption(USE_FSAL_GLUSTER "build GLUSTER FSAL shared library" ON)
goption(USE_FSAL_NULL "build NULL FSAL shared library" ON)
goption(USE_FSAL_RGW "build RGW FSAL shared library" ON)
goption(USE_FSAL_MEM "build Memory FSAL shared library" ON)

# Internal capability required by some FSALs
option(GSH_CAN_HOST_LOCAL_FS "Ganesha supports hosting local filesystems" ON)

# nTIRPC
option(USE_SYSTEM_NTIRPC "Use the system nTIRPC, rather than the submodule" OFF)
option (USE_GSS "enable RPCSEC_GSS support" ON)
option(TIRPC_EPOLL "platform supports EPOLL or emulation" ON)

# Build configure options
goption(USE_DBUS "enable DBUS protocol support" ON)

# Various DBUS enabled features

=== src/FSAL/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
# Add the directory for stackable FSALs
add_subdirectory(Stackable_FSALs)

# Add the directory for Pseudo FSAL
add_subdirectory(FSAL_PSEUDO)

# All we need to do here is control the
# build of chosen fsals
if(USE_FSAL_PROXY_V4)
  add_subdirectory(FSAL_PROXY_V4)
endif(USE_FSAL_PROXY_V4)

if(USE_FSAL_PROXY_V3)
  add_subdirectory(FSAL_PROXY_V3)
endif(USE_FSAL_PROXY_V3)

if(USE_FSAL_CEPH)
  add_subdirectory(FSAL_CEPH)
endif(USE_FSAL_CEPH)

if(USE_FSAL_RGW)
  add_subdirectory(FSAL_RGW)
endif(USE_FSAL_RGW)

if(USE_FSAL_GPFS)
  add_subdirectory(FSAL_GPFS)
endif(USE_FSAL_GPFS)

if(USE_FSAL_VFS OR USE_FSAL_LUSTRE OR USE_FSAL_XFS)
  add_subdirectory(FSAL_VFS)
endif(USE_FSAL_VFS OR USE_FSAL_LUSTRE OR USE_FSAL_XFS)

if(USE_FSAL_GLUSTER)
  add_subdirectory(FSAL_GLUSTER)
endif(USE_FSAL_GLUSTER)

if(USE_FSAL_LIZARDFS)
  add_subdirectory(FSAL_LIZARDFS)
endif(USE_FSAL_LIZARDFS)

if(USE_FSAL_KVSFS)
  add_subdirectory(FSAL_KVSFS)
endif(USE_FSAL_KVSFS)

if(USE_FSAL_MEM)
  add_subdirectory(FSAL_MEM)
endif(USE_FSAL_MEM)

=== src/MainNFSD/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
add_definitions(
  -D__USE_GNU
)

if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

if(RADOS_URLS)
  include_directories(
	  ${RADOS_INCLUDE_DIR}
    )
endif(RADOS_URLS)
########### next target ###############

SET(MainServices_STAT_SRCS
   nfs_admin_thread.c
   nfs_rpc_callback.c
   nfs_worker_thread.c
   nfs_rpc_dispatcher_thread.c
   nfs_rpc_tcp_socket_manager_thread.c
   nfs_init.c
   nfs_lib.c
   nfs_reaper_thread.c
   ../support/client_mgr.c
)

if(USE_9P)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_dispatcher.c)
endif(USE_9P)

if(USE_9P AND USE_9P_RDMA)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_rdma_dispatcher.c
    9p_rdma_callbacks.c)
endif(USE_9P AND USE_9P_RDMA)

if(USE_NFS_RDMA)
  add_definitions(-D_USE_NFS_RDMA)
endif(USE_NFS_RDMA)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c)
endif(USE_CB_SIMULATOR)

if(USE_UPCALL_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    fsal_upcall_simulator_thread.c
    )
endif(USE_UPCALL_SIMULATOR)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c
    )
endif(USE_CB_SIMULATOR)

add_library(MainServices OBJECT ${MainServices_STAT_SRCS})
add_sanitizers(MainServices)
set_target_properties(MainServices PROPERTIES COMPILE_FLAGS "-fPIC")

# FSAL core sources
# fsal_manager and fsal_destroyer are the only objects referenced by the
# core server all the rest are for the common support of fsal plugins.

set(fsal_CORE_SRCS
   ../FSAL/fsal_convert.c
   ../FSAL/commonlib.c
   ../FSAL/fsal_manager.c
   ../FSAL/access_check.c
   ../FSAL/fsal_config.c
   ../FSAL/default_methods.c
   ../FSAL/common_pnfs.c
   ../FSAL/fsal_destroyer.c
   ../FSAL/fsal_helper.c
   ../FSAL_UP/fsal_up_top.c
   ../FSAL_UP/fsal_up_async.c
)

if (GSH_CAN_HOST_LOCAL_FS)
  set(fsal_CORE_SRCS
      ${fsal_CORE_SRCS}
      ../FSAL/localfs.c
  )
endif(GSH_CAN_HOST_LOCAL_FS)

if (USE_ACL_MAPPING)
  set(fsal_CORE_SRCS
      ${fsal_CORE_SRCS}
      ../FSAL/posix_acls.c
  )
endif(USE_ACL_MAPPING)

set(ganesha_nfsd_OBJS
    $<TARGET_OBJECTS:MainServices>
    $<TARGET_OBJECTS:avltree>
    $<TARGET_OBJECTS:cidr>
    $<TARGET_OBJECTS:config_parsing>
    $<TARGET_OBJECTS:hashtable>
    $<TARGET_OBJECTS:idmap>
    $<TARGET_OBJECTS:log>
    $<TARGET_OBJECTS:gos>
    $<TARGET_OBJECTS:rpcal>
    $<TARGET_OBJECTS:sal>
    $<TARGET_OBJECTS:support>
    $<TARGET_OBJECTS:string_utils>
    $<TARGET_OBJECTS:hash>
    $<TARGET_OBJECTS:uid2grp>
    $<TARGET_OBJECTS:netgroup_cache>
    $<TARGET_OBJECTS:nfsproto>
    $<TARGET_OBJECTS:nfs4callbacks>
    $<TARGET_OBJECTS:nfs_mnt_xdr>
    $<TARGET_OBJECTS:fsalpseudo>
    $<TARGET_OBJECTS:fsalmdcache>
)

if(USE_DBUS)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:gshdbus>
  )
endif(USE_DBUS)

if(USE_NLM)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:nlm>
  )
endif(USE_NLM)

if(USE_RQUOTA)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:rquota>
  )
endif(USE_RQUOTA)

if(USE_NFSACL3)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
  $<TARGET_OBJECTS:nfsacl>
  )
endif(USE_NFSACL3)

if(USE_9P)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:9p>
  )
endif(USE_9P)

add_library(ganesha_nfsd SHARED
  ${ganesha_nfsd_OBJS} ${fsal_CORE_SRCS}
)

add_sanitizers(ganesha_nfsd)

target_link_libraries(ganesha_nfsd
  ${LIBTIRPC_LIBRARIES}
  ${SYSTEM_LIBRARIES}
  ${LTTNG_LIBRARIES}
  ${MOOSHIKA_LIBRARIES}
)

if(SANITIZE_ADDRESS)
  set(undef_flags ${LDFLAG_ALLOW_UNDEF})
else(SANITIZE_ADDRESS)
  set(undef_flags ${LDFLAG_DISALLOW_UNDEF})
endif(SANITIZE_ADDRESS)

if(LINUX OR FREEBSD)
  # Apple's /bin/ld does not support the --version-script flag.
  set(ver_script_flags "-Wl,--version-script=${GANESHA_TOP_CMAKE_DIR}/MainNFSD/libganesha_nfsd.ver")
endif(LINUX OR FREEBSD)

set_target_properties(ganesha_nfsd PROPERTIES LINK_FLAGS "${undef_flags} ${ver_script_flags}")

set_target_properties(ganesha_nfsd PROPERTIES
  VERSION "${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}"
  SOVERSION "${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}"
)
install(TARGETS ganesha_nfsd LIBRARY DESTINATION ${LIB_INSTALL_DIR})

#install(TARGETS ganesha.nfsd COMPONENT daemon DESTINATION bin)

########### install files ###############

# We are still missing the install of docs and stuff

=== src/SAL/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
########### next target ###############

SET(sal_STAT_SRCS
   state_async.c
   state_lock.c
   state_share.c
   state_misc.c
   state_layout.c
   state_deleg.c
   nfs4_clientid.c
   nfs4_state.c
   nfs4_state_id.c
   nfs4_lease.c
   nfs4_recovery.c
   nfs41_session_id.c
   nfs4_owner.c
   recovery/recovery_fs.c
   recovery/recovery_fs_ng.c
)

if(USE_NLM)
  set(sal_STAT_SRCS
    ${sal_STAT_SRCS}
    nlm_owner.c
    nlm_state.c
    )
endif(USE_NLM)

if(USE_9P)
  set(sal_STAT_SRCS
    ${sal_STAT_SRCS}
    9p_owner.c
    )
endif(USE_9P)

add_library(sal OBJECT ${sal_STAT_SRCS})
add_sanitizers(sal)
set_target_properties(sal PROPERTIES COMPILE_FLAGS "-fPIC")

if(USE_RADOS_RECOV)
  set(sal_RADOS_SRCS
    recovery/recovery_rados_kv.c
    recovery/recovery_rados_ng.c
    recovery/recovery_rados_cluster.c
    ../support/rados_grace.c
    )
  add_library(ganesha_rados_recov MODULE ${sal_RADOS_SRCS})
  add_sanitizers(ganesha_rados_recov)
  target_link_libraries(ganesha_rados_recov
    ganesha_nfsd
    ${SYSTEM_LIBRARIES}
    ${RADOS_LIBRARIES}
    ${LDFLAG_DISALLOW_UNDEF})
  include_directories(${RADOS_INCLUDE_DIR})
  set_target_properties(ganesha_rados_recov PROPERTIES SOVERSION
    "${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}")
  install(TARGETS ganesha_rados_recov LIBRARY DESTINATION ${LIB_INSTALL_DIR})
endif(USE_RADOS_RECOV)

########### install files ###############

=== src/avl/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------

########### next target ###############

SET(avltree_STAT_SRCS
   avl.c
   bst.c
   rb.c
   splay.c
)

add_library(avltree OBJECT ${avltree_STAT_SRCS})
add_sanitizers(avltree)
set_target_properties(avltree PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/cidr/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------

########### next target ###############

SET(cidr_STAT_SRCS
   cidr_addr.c
   cidr_compare.c
   cidr_from_str.c
   cidr_get.c
   cidr_inaddr.c
   cidr_mem.c
   cidr_misc.c
   cidr_net.c
   cidr_num.c
   cidr_to_str.c
   cidr_pow2_p.h
)

add_library(cidr OBJECT ${cidr_STAT_SRCS})
add_sanitizers(cidr)
set_target_properties(cidr PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/config_parsing/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
find_package(BISON)
find_package(FLEX)

add_definitions(
  -D__USE_GNU
)

BISON_TARGET(
  ConfigParser
  ${CMAKE_CURRENT_SOURCE_DIR}/conf_yacc.y
  ${CMAKE_CURRENT_BINARY_DIR}/conf_yacc.c
  COMPILE_FLAGS "--defines -pganesha_yy"
)

FLEX_TARGET(
  ConfigScanner
  ${CMAKE_CURRENT_SOURCE_DIR}/conf_lex.l
  ${CMAKE_CURRENT_BINARY_DIR}/conf_lex.c
  COMPILE_FLAGS "-Pganeshun_yy -olex.yy.c"
)

ADD_FLEX_BISON_DEPENDENCY(ConfigScanner ConfigParser)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

########### next target ###############

SET(config_parsing_STAT_SRCS
   analyse.c
   config_parsing.c
   conf_url.c
   analyse.h
)

add_library(config_parsing OBJECT
  ${config_parsing_STAT_SRCS}
  ${BISON_ConfigParser_OUTPUTS}
  ${FLEX_ConfigScanner_OUTPUTS}
)

add_sanitizers(config_parsing)
set_target_properties(config_parsing PROPERTIES COMPILE_FLAGS "-fPIC")

if(RADOS_URLS)
  set(config_parsing_RADOS_SRCS
    ${config_parsing_RADOS_SRCS}
    conf_url_rados.c
    )
  add_library(ganesha_rados_urls MODULE ${config_parsing_RADOS_SRCS})
  add_sanitizers(ganesha_rados_urls)
  target_link_libraries(ganesha_rados_urls
    ganesha_nfsd
    ${SYSTEM_LIBRARIES}
    ${RADOS_LIBRARIES}
    ${LDFLAG_DISALLOW_UNDEF})
  include_directories(${RADOS_INCLUDE_DIR})
  set_target_properties(ganesha_rados_urls PROPERTIES SOVERSION
    "${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}")
  install(TARGETS ganesha_rados_urls LIBRARY DESTINATION ${LIB_INSTALL_DIR})

endif(RADOS_URLS)

########### install files ###############

=== src/doc/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
if(USE_MAN_PAGE)
  add_subdirectory(man)
endif(USE_MAN_PAGE)

=== src/hashtable/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
########### next target ###############

SET(hashtable_STAT_SRCS
   hashtable.c
)

add_library(hashtable OBJECT ${hashtable_STAT_SRCS})
add_sanitizers(hashtable)
set_target_properties(hashtable PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/log/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
add_definitions(
  -D__USE_GNU
)

if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

if(USE_LTTNG)
  include_directories(
    ${LTTNG_INCLUDE_DIR}
  )
endif(USE_LTTNG)

########### next target ###############

SET(log_STAT_SRCS
   display.c
   log_functions.c
)

add_library(log OBJECT ${log_STAT_SRCS})
add_sanitizers(log)
set_target_properties(log PROPERTIES COMPILE_FLAGS "-fPIC")

########### next target ###############

SET(test_liblog_SRCS
   test_display.c
)

########### install files ###############

=== src/os/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
# All we need to do here is control the
# build of chosen platform

if(FREEBSD)
  SET(gos_STAT_SRCS
      freebsd/atsyscalls.c
      freebsd/mntent_compat.c
      freebsd/subr.c
      freebsd/xattr.c
  )
endif(FREEBSD)

if(DARWIN)
  SET(gos_STAT_SRCS
      darwin/sys_resource.c
  )
endif(DARWIN)

if(LINUX)
  SET(gos_STAT_SRCS
      linux/acl.c
      linux/subr.c
  )
endif(LINUX)

add_library(gos OBJECT ${gos_STAT_SRCS})
add_sanitizers(gos)
set_target_properties(gos PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/scripts/CMakeLists.txt ===
# SPDX-License-Identifier: LGPL-3.0-or-later
#-------------------------------------------------------------------------------
#
# Copyright Panasas, 2012
# Contributor: Jim Lieb <jlieb@panasas.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
#-------------------------------------------------------------------------------
if(USE_ADMIN_TOOLS)
  add_subdirectory(ganeshactl)
  add_subdirectory(gpfs-epoch)
endif(USE_ADMIN_TOOLS)

=== debian/changelog ===
nfs-ganesha (4.3-8) unstable; urgency=medium

  * second try of fix builds on archs without ceph

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 30 Oct 2023 22:32:53 +0100

nfs-ganesha (4.3-7) unstable; urgency=medium

  * fix builds on archs without ceph

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 30 Oct 2023 15:35:39 +0100

nfs-ganesha (4.3-6) unstable; urgency=medium

  * only configure with ceph for some 64bit archs

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 05 Oct 2023 11:17:56 +0200

nfs-ganesha (4.3-5) unstable; urgency=medium

  * only configure with gluster on 64bit arch

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 08 Sep 2023 12:12:29 +0200

nfs-ganesha (4.3-4) unstable; urgency=medium

  * build gluster package only on supported architectures (closes:
    #1041998)

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 07 Sep 2023 19:52:03 +0200

nfs-ganesha (4.3-3) unstable; urgency=medium

  * fix clean target (closes: Bug#1049469)
  * wrap-and-sort debian files

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 05 Sep 2023 09:29:07 +0200

nfs-ganesha (4.3-2) unstable; urgency=high

  * include breaks and replaces to fix update of nfs-ganesha-ceph (closes:
    #1034925)

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 28 Apr 2023 12:25:51 +0200

nfs-ganesha (4.3-1) unstable; urgency=medium

  * New upstream version 4.3

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 25 Jan 2023 10:37:33 +0100

=== debian/control ===
Source: nfs-ganesha
Section: net
Priority: optional
Maintainer: Philippe Deniel <philippe.deniel@cea.fr>
Uploaders:
 Christoph Martin <martin@uni-mainz.de>,
Standards-Version: 4.5.1
Homepage: https://github.com/nfs-ganesha/nfs-ganesha
Build-Depends:
 bison,
 cmake,
 debhelper (>= 10),
 dh-python,
 flex,
 libacl1-dev,
 libattr1-dev,
 libblkid-dev,
 libcap-dev,
 libcephfs-dev,
 libdbus-1-dev,
 libglusterfs-dev (>= 9.0) [amd64 arm64 ia64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
 libkrb5-dev,
 liblttng-ctl-dev,
 liblttng-ust-dev,
 libnfsidmap-dev,
 libntirpc-dev (>= 4.3),
 libpython3-all-dev,
 librados-dev [amd64 arm64 mips64el ppc64el riscv64 s390x],
 librgw-dev [amd64 arm64 mips64el ppc64el riscv64 s390x],
 liburcu-dev,
 libwbclient-dev,
 lttng-tools,
 pkgconf,
 pyqt5-dev-tools,
 python3-all-dev,
 python3-pyqt5,
 python3-setuptools,
 python3-sphinx,
 uuid-dev,
 xfslibs-dev,
Vcs-Git: https://salsa.debian.org/debian/nfs-ganesha.git
Vcs-Browser: https://salsa.debian.org/debian/nfs-ganesha

Package: nfs-ganesha
Multi-Arch: foreign
Architecture: any
Depends:
 dbus,
 nfs-common,
 rpcbind,
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Description: NFS server in User Space
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains the binaries

Package: nfs-ganesha-ceph
Architecture: amd64 arm64 mips64el ppc64el riscv64 s390x
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 nfs-ganesha (<< 4.0-1),
Breaks:
 nfs-ganesha (<< 4.0-1),
Description: nfs-ganesha fsal ceph libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_CEPH and an example ceph.conf file

Package: nfs-ganesha-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Multi-Arch: foreign
Description: Documentation for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains documentation and examples for nfs-ganesha

Package: nfs-ganesha-gluster
Multi-Arch: same
Architecture: amd64 arm64 ia64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Section: libs
Depends:
 libglusterfs0 (>= 6.0),
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal gluster libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for FSAL_GLUSTER and an example .conf file

Package: nfs-ganesha-gpfs
Multi-Arch: same
Architecture: any
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal gpfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_GPFS and conf files.

Package: nfs-ganesha-mem
Multi-Arch: same
Architecture: any
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal mem libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_MEM

Package: nfs-ganesha-mount-9p
Architecture: all
Depends:
 nfs-ganesha (>=${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: nfs-ganesha mount.9P
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains mount.9P

Package: nfs-ganesha-nullfs
Multi-Arch: same
Architecture: any
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal nullfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_NULLFS

Package: nfs-ganesha-proxy-v4
Multi-Arch: same
Architecture: any
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal proxy v4 libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_PROXY_V4

Package: nfs-ganesha-rados-grace
Multi-Arch: foreign
Architecture: amd64 arm64 mips64el ppc64el riscv64 s390x
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha ganesha-rados-grace program
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains the ganesha-rados-grace program

Package: nfs-ganesha-rgw
Multi-Arch: same
Architecture: amd64 arm64 mips64el ppc64el riscv64 s390x
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal rgw libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_RGW and an example rgw.conf file

Package: nfs-ganesha-vfs
Multi-Arch: same
Architecture: any
Section: libs
Depends:
 nfs-ganesha (=${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: nfs-ganesha fsal vfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains a library for a FSAL_VFS and an example vfs.conf file

Package: python3-nfs-ganesha
Pre-Depends:
 ${misc:Pre-Depends},
Replaces:
 python-nfs-ganesha,
Architecture: all
Section: python
Provides:
 ${python:Provides},
Depends:
 python3-dbus,
 python3-pyqt5,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains Python bindings for nfs-ganesha admin

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Expected debian/rules file that is used by the dpkg build procedure
#
#   $ git clone <nfs-ganesha>
#   $ cd nfs-ganesha/src
#   $ dpkg-buildpackage -uc -us
#
export PREFIX=/usr
export DESTDIR=$(CURDIR)/debian/tmp
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
ifeq ($(DEB_HOST_ARCH_BITS),64)
  FSALGLUSTER=-DUSE_FSAL_GLUSTER=YES
else
  FSALGLUSTER=-DUSE_FSAL_GLUSTER=NO
endif
ifneq (,$(findstring $(DEB_HOST_ARCH),"amd64 arm64 mips64el ppc64el riscv64 s390x"))
  FSALCEPH=-DUSE_FSAL_CEPH=YES -DUSE_FSAL_RGW=YES
  RADOSOPT=-DUSE_RADOS_RECOV=YES -DRADOS_URLS=YES
else
  FSALCEPH=-DUSE_FSAL_CEPH=NO -DUSE_FSAL_RGW=NO
  RADOSOPT=-DUSE_RADOS_RECOV=NO -DRADOS_URLS=NO
endif
%:
	 dh $@ --with python3

#		-DPython_EXECUTABLE=$(shell which python) \
#		-DPython_INCLUDE_DIR=$(shell python -c "from distutils.sysconfig import get_python_inc; print(get_python_inc())") \
#		-DPython_LIBRARY=$(shell python -c "import distutils.sysconfig as sysconfig; print(sysconfig.get_config_var('LIBDIR'))") \
#		-DPython_Interpreter=$(shell which python) \

override_dh_auto_configure:
	 cd src && ln -s ../debian .
	 cd src && dh_auto_configure -- \
		--log-level=VERBOSE \
                -DWITH_PYTHON3=3 \
		-DBUILD_CONFIG=debian \
		-DLIB_INSTALL_DIR=/usr/lib/ganesha \
		-DFSAL_DESTINATION=/usr/lib/${DEB_HOST_MULTIARCH}/ganesha \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_FSAL_NULL=YES \
		-DUSE_FSAL_MEM=YES \
		-DUSE_FSAL_XFS=NO \
		-DUSE_FSAL_LUSTRE=NO \
		${FSALCEPH} \
		-DUSE_FSAL_GPFS=YES \
		-DUSE_FSAL_KVSFS=NO \
		${FSALGLUSTER} \
		-DUSE_SYSTEM_NTIRPC=YES \
		-DUSE_9P_RDMA=NO \
		-DUSE_LTTNG=NO \
		-DUSE_ADMIN_TOOLS=YES \
		${RADOSOPT} \
		-DUSE_GUI_ADMIN_TOOLS=YES \
		-DUSE_FSAL_VFS=ON \
		-DUSE_FSAL_PROXY_V4=ON \
		-DUSE_FSAL_PROXY_V3=OFF\
		-DUSE_DBUS=ON \
		-DUSE_9P=ON \
		-DDISTNAME_HAS_GIT_DATA=OFF \
		-DUSE_MAN_PAGE=YES \
		-D_MSPAC_SUPPORT=YES \
		-DSANITIZE_ADDRESS=NO


override_dh_auto_build:
	cd src && dh_auto_build

override_dh_auto_test:

override_dh_install:
	mkdir -p debian/tmp/etc/ganesha/
	mkdir -p debian/tmp/lib/systemd/system/
	mkdir -p debian/tmp/etc/systemd/system/nfs-ganesha-lock.service.d
	mkdir -p debian/tmp/etc/init.d
	mkdir -p debian/tmp/etc/default
	mkdir -p debian/tmp/etc/logrotate.d/
	mkdir -p debian/tmp/etc/dbus-1/system.d/
	mkdir -p debian/tmp/usr/lib/ganesha
	mkdir -p debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ganesha
	mkdir -p debian/tmp/usr/sbin/
	cp src/config_samples/ganesha.conf.example debian/tmp/etc/ganesha/
	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/
	cp src/config_samples/rgw.conf debian/tmp/etc/ganesha/
	cp src/config_samples/mem.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gluster.conf debian/tmp/etc/ganesha/
	cp src/config_samples/ceph.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.exports.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.log.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.main.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.nfsd.conf debian/tmp/etc/ganesha/
	cp src/config_samples/logrotate_ganesha debian/tmp/etc/logrotate.d/nfs-ganesha
	cp src/config_samples/logrotate_fsal_gluster debian/tmp/etc/logrotate.d/nfs-ganesha-gfapi
	cp src/scripts/systemd/nfs-ganesha.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha.service
	cp src/scripts/systemd/nfs-ganesha-config.service debian/tmp/lib/systemd/system/
	cp src/scripts/systemd/nfs-ganesha-lock.service.debian10 debian/tmp/lib/systemd/system/nfs-ganesha-lock.service
	cp src/scripts/systemd/rpc-statd.conf.debian10 debian/tmp/etc/systemd/system/nfs-ganesha-lock.service.d/rpc-statd.conf
	cp src/scripts/systemd/sysconfig/nfs-ganesha debian/tmp/etc/default/
	cp src/scripts/init.d/nfs-ganesha.debian8 debian/tmp/etc/init.d/
	cp src/scripts/ganeshactl/org.ganesha.nfsd.conf debian/tmp/etc/dbus-1/system.d/nfs-ganesha-dbus.conf
	install -m 0755 src/scripts/nfs-ganesha-config.sh debian/tmp/usr/lib/ganesha/
	install -m 0755 src/tools/mount.9P debian/tmp/usr/sbin/
	make -C src/obj-*-linux-gnu* install
	dh_install --sourcedir=./src

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/${DEB_HOST_MULTIARCH}/ganesha

override_dh_clean:
	dh_clean
	rm -fv src/debian src/nfs-ganesha.spec src/scripts/systemd/nfs-ganesha-config.service
	rm -frv src/obj-x86_64-linux-gnu/
	rm -frv src/scripts/ganeshactl/ganeshactl.egg-info
	rm -frv src/scripts/gpfs-epoch/gpfs.egg-info
